/*
 * 		test des trucs
 */

#include  <stdio.h>
#include  <stdlib.h>
#include  <unistd.h>
#include  <string.h>

#include  "../floatimg.h"
#include  "glitches.h"
#include  "sfx.h"
#include  "filterstack.h"

/* ----------------------------------------------------------- */

int		verbosity;
int		convert_to_gray;	/* WTF ? */

#define		PNG	"out.png"
#define		W	800
#define		H	600
#define		LMAX	255.0
#define		TIMER	1

#define		STK	0

/* ----------------------------------------------------------- */

int essai_filterstack(char *fname)
{
int		foo;
FloatImg	image;
double		debut, fin;

filterstack_list(STK, __func__);

foo = fimg_create_from_dump(fname, &image);
if (foo) {
	fprintf(stderr, "err %d create image\n", foo);
	exit(1);
	}

srand(getpid()); srand48(getpid());

debut = fimg_timer_set(TIMER);

foo = filterstack_run(STK, &image, 0);
if (foo) {
	fprintf(stderr, "filterstack run --> %d\n", foo);
	return foo;
	}

fin = fimg_timer_set(TIMER);

foo = fimg_save_as_png(&image, "foo.png", 0);
if (foo) {
	fprintf(stderr, "erreur export %d\n", foo);
	}

fprintf(stderr, "elapsed %f\n", fin-debut);

fimg_destroy(&image);

return 0;
}
/* ----------------------------------------------------------- */
int help(void)
{
puts("yolo!");
exit(0);
}
/* ----------------------------------------------------------- */

int main(int argc, char *argv[])
{
int		foo;
int		opt;
char		*filterchain = "0";

fprintf(stderr, "*** %s : compiled by tTh, %s %s\n", __FILE__,
			__DATE__, __TIME__);
fimg_print_version(2);

while ((opt = getopt(argc, argv, "hF:v")) != -1) {
	switch(opt) {
		case 'h':	help();			break;
		case 'F':	filterchain = optarg;	break;
		case 'v':	verbosity++;		break;
		}
	}

#if DEBUG_LEVEL
fprintf(stderr, "%s : argc = %d, optind = %d\n", argv[0], argc, optind);
#endif

foo = parse_filter_chain(STK, filterchain);
if (foo) {
	fprintf(stderr, "err %d in parse_filter_chain\n", foo);
	exit(1);
	}

foo = essai_filterstack("mire.fimg");
if (foo) {
	fprintf(stderr, "err %d in essai_filterstack\n", foo);
	exit(1);
	}

return 0;
}

/* ----------------------------------------------------------- */
